/**
 * An implementation of the LoD check using just two
 * concrete aspects, with two 2-line advise each (and
 * a few short auxiliary methods.)
 * 
 * @authors David H. Lorenz and Pengcheng Wu
 * @version 0.4, 12/19/02
 */
/*** THIS MUST BE LINE 9 ***/
package MetaLawOfDemeter;
public abstract class Any {
  public pointcut StaticInitialization(): 
     meta staticinitialization(*);
  public pointcut MethodCallSite(): 
     meta call(* *(..));
  public pointcut ConstructorCall(): 
     meta call(*.new (..));
  public pointcut MethodExecution(): 
     meta execution(* *(..)); 
  public pointcut ConstructorExecution(): 
     meta execution(*.new (..));
  public pointcut Execution(): 
    ConstructorExecution() || MethodExecution()|| AdviceExecution() ; 
  public pointcut MethodCall(Object thiz,
    Object targt): MethodCallSite()
    && meta this(thiz) 
    && meta target(targt);
  public pointcut SelfCall(Object thiz,
    Object targt): MethodCall(thiz,targt)
    && meta if(thiz == targt);
  public pointcut StaticCall(): 
    meta call(static * *(..));
  public pointcut Set(Object value): 
    meta set(* *.*) && meta args(value); 
  public pointcut Initialization():
     meta initialization(*.new(..)); 
 public pointcut AdviceExecution():
  	 adviceexecution();

}
